include_recipe 'ec2helper'
include_recipe 'PsTools'

if node[:tfs][:version] == '2015'
	remote_file "#{node[:tfs][:build_agent_zipfile_path]}" do
		source "#{node[:tfs][:build_agent_zipfile_url]}"
		action :create
		headers( "Authorization"=>"Basic #{ Base64.encode64("#{node[:tfs][:username]}:#{node[:tfs][:password]}").gsub("\n", "") }" )
		notifies :unzip, "windows_zipfile[#{node[:tfs][:build_agent_dir]}]", :immediately
	end
else
	remote_file "#{node[:tfs][:build_agent_zipfile_path]}" do
		source "#{node[:tfs][:build_agent_zipfile_url]}"
		action :create
		notifies :unzip, "windows_zipfile[#{node[:tfs][:build_agent_dir]}]", :immediately
	end
end

windows_zipfile "#{node[:tfs][:build_agent_dir]}" do
	source "#{node[:tfs][:build_agent_zipfile_path]}"
	not_if { File.exist?("#{node[:tfs][:build_agent_command_file_path]}") }
	action :nothing
end

if node[:tfs][:version] == '2015'
	LogFileInstallAgent = "#{Chef::Config[:cache_path]}/InstallAgent.log"

	execute 'InstallAgent' do
		command "#{node[:PsTools][:exe_path]} -high -u \"#{node[:tfs][:username]}\" -p \"#{node[:tfs][:password]}\" -h -accepteula #{node[:tfs][:build_agent_command_file_path]} /ServerUrl:http://#{node[:tfs][:application_server_fqdn]}:8080/tfs /Configure /Name:#{ENV['COMPUTERNAME']} /force /RunningAsService /PoolName:default  /WindowsServiceLogonAccount:\"#{node[:tfs][:build_agent_account_name]}\" /NoPrompt /WindowsServiceLogonPassword:\"xxx\""
	end
else
	execute 'InstallAgent' do
		command "#{node[:tfs][:build_agent_dir]}/config.cmd --unattended --url #{default[:tfs][:public_url]} --auth Integrated --pool default --agent myagent --runasservice"
	end
end